/* 
 * Copyright 2004 Timo Hirvonen
 *
 * Copyright (c) 2006 Ed Schouten <ed@fxq.nl>
 * All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id$
 */

#ifndef _NOMAD_H_
#define _NOMAD_H_

#include <stdio.h>

/* always 16-bit signed little-endian */
struct nomad_info {
	double duration;
	int sample_rate;
	int channels;
	int nr_frames;
	int layer;
	/* -1 if fast = 1 */
	int vbr;
	/* -1 if fast = 1 */
	int avg_bitrate;
	/* -1 if file not seekable */
	int filesize;
	unsigned int joint_stereo : 1;
	unsigned int dual_channel : 1;
};

struct nomad;

struct nomad *nomad_open(FILE *fd);

void nomad_close(struct nomad *nomad);
struct nomad_info *nomad_info(struct nomad *nomad);

int nomad_read(struct nomad *nomad, char *buffer, int count);

int nomad_time_seek(struct nomad *nomad, double pos);

double nomad_time_tell(struct nomad *nomad);
double nomad_time_total(struct nomad *nomad);

#endif /* _NOMAD_H_ */
